#include "openssl_errors.hpp"

#include "c_callback.hpp"

#include <boost/log/trivial.hpp>

auto log_openssl_errors(const std::string_view prefix) -> void
{
    auto err_cb = [prefix](const char *str, size_t len) -> int {
        BOOST_LOG_TRIVIAL(error) << prefix << std::string_view{str, len};
        return 0;
    };
    ERR_print_errors_cb(CCallback<decltype(err_cb)>::invoke, &err_cb);
}
