#include "settings.hpp"

#define TOML_ENABLE_FORMATTERS 0
#include <toml++/toml.hpp>

auto Settings::from_stream(std::istream &in) -> Settings
{
    const auto config = toml::parse(in);
    return Settings{
        .host = config["host"].value_or(std::string{}),
        .service = config["port"].value_or(std::uint16_t{6667}),
        .password = config["password"].value_or(std::string{}),
        .username = config["username"].value_or(std::string{}),
        .realname = config["realname"].value_or(std::string{}),
        .nickname = config["nickname"].value_or(std::string{}),
        .sasl_mechanism = config["sasl_mechanism"].value_or(std::string{}),
        .sasl_authcid = config["sasl_authcid"].value_or(std::string{}),
        .sasl_authzid = config["sasl_authzid"].value_or(std::string{}),
        .sasl_password = config["sasl_password"].value_or(std::string{}),
        .tls_hostname = config["tls_hostname"].value_or(std::string{}),
        .tls_certfile = config["tls_certfile"].value_or(std::string{}),
        .tls_keyfile = config["tls_keyfile"].value_or(std::string{}),
        . challenge_username = config["challenge_username"].value_or(std::string{}),
        . challenge_key_file = config["challenge_key_file"].value_or(std::string{}),
        . challenge_key_password = config["challenge_key_password"].value_or(std::string{}),
        .use_tls = config["use_tls"].value_or(false),
    };
}
